# [PYDAMIC](https://github.com/urya500/pydamic) &middot; [![GitHub license](https://img.shields.io/badge/license-MIT-blue.svg)](https://github.com/urya500/pydamic/blob/main/LICENSE) [![PyPI version](https://img.shields.io/pypi/v/pydamic.svg)](https://pypi.org/project/pydamic/) [![Python version](https://img.shields.io/badge/python-3.7%2B-blue.svg)](https://www.python.org/downloads/) 

**PYDAMIC** is a Python library designed for learning and implementing common data structures and algorithms. Whether you're a beginner or an advanced user, this library will help you visualize, experiment, and learn about data structures like stacks, queues, trees, linked lists, and more. Extendable with custom algorithms and data structures, PYDAMIC is the perfect tool for students, educators, and developers.

## 🚀 Features

- **Data Structures**:
  - **Stacks**
  - **Queues**
  - **Linked Lists**
  - **Binary Trees**
  - **More to come...**

- **Algorithms**:
  - **Searching**: Binary Search, BFS, DFS
  - **Sorting**: Bubble Sort, Quick Sort, Merge Sort
  - **Pathfinding**: A*, Dijkstra
  - **Machine Learning Algorithms**: Linear Regression, KNN

- **Extendable**:
  - Easily add your custom data structures and algorithms using inheritance.

## 📦 Installation

To install **PYDAMIC** via `pip`, run:

```bash
pip install pydamic